/**********************************************************************
File Name:              twitter.c
Dev:                    Daniele De Santis
Email:                  desantis@areasx.com
Web:                    http://www.areasx.com

Versione:               1.0
Data:                   14/09/11
Note Hardware:          FlyPort
Note Software:          OpenPicus IDE v2.0
                        TwittHTTP (www.desantix.it/twitter/)
**********************************************************************/
#include "TCPlib.h"
#define TWITTER_APP_SRV   "www.desantix.it"
#define TWITTER_APP_PATH  "/twitter/twitthttp/"

/**********************************************************************
DESCRIPTION:  Trasmissione di un messaggio Twitter tramite Gateway TwittHTTP

PARAMETER:    TwitterStatus   messaggio da twittare max 140 caratteri
              TwitterToken    token (www.desantix.it/twitter/register.php)

RETURN VALUE: 0 trasmissione riuscita
              1 TwitterStatus  composto da 0 caratteri
              2 TwitterToken non fornito
              3 TwitterToken non registrato (www.desantix.it/twitter/register.php)
              4 Errore server twitter (autenticazione o messaggio doppio)
              10 connessione tcp/ip fallita
**********************************************************************/
int Twitter(char* TwitterStatus, char* TwitterToken){
  TCP_SOCKET TcpID;
  DWORD      T0;
  char       PostQuery[255];
  int        RxChar;
  char       Buffer[255];
  
  TcpID = TCPClientOpen (TWITTER_APP_SRV, "80");
  T0 = TickGet();
  while((TcpID==INVALID_SOCKET)){
    if(TickGet() - T0 > 20 * TICK_SECOND) return 10;
  }
  T0 = TickGet();
  while(TCPisConn(TcpID)==FALSE){
    if((TickGet()-T0)> 30*TICK_SECOND) return 10;
  }
  sprintf(PostQuery, "status=%s&token=%s",TwitterStatus,TwitterToken);
  sprintf(Buffer, "POST %s HTTP/1.1\r\nHost: %s\r\nUser-Agent: Mozilla/4.0\r\nContent-Length: %d\r\nContent-Type: application/x-www-form-urlencoded\r\n\r\n", TWITTER_APP_PATH, TWITTER_APP_SRV,(int)strlen(PostQuery));
  TCPWrite (TcpID, Buffer, (int)strlen(Buffer));
  TCPWrite (TcpID, PostQuery, (int)strlen(PostQuery));
  TCPWrite (TcpID, "\r\n", 2);
  T0=TickGet();
  do {
    RxChar = TCPRxLen(TcpID); 
    if(RxChar>0){
      if(RxChar>sizeof(Buffer)) RxChar=sizeof(Buffer); 
      T0=TickGet();
      TCPRead (TcpID, Buffer, RxChar);
      Buffer[RxChar]=0;
    }
    if((TickGet()-T0) > 30*TICK_SECOND) {
      TCPClientClose(TcpID);
      return 10;
    }
  } while(TCPisConn(TcpID) || TCPRxLen(TcpID)>0); 
  TCPClientClose(TcpID);
  if(strlen(Buffer)>0){
    if ( strstr(Buffer,"TX OK")!=NULL )
      return 0;
    else {
      if (strstr(Buffer,"ERROR 1")!=NULL )     return 1;
      else if (strstr(Buffer,"ERROR 2")!=NULL) return 2;
      else if (strstr(Buffer,"ERROR 3")!=NULL) return 3;
      else if (strstr(Buffer,"ERROR 4")!=NULL) return 4;
    }
  }
  return 10;
}

